<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ArtikelMenge StructType
 * Meta informations extracted from the WSDL
 * - documentation: Artikel mit Menge
 * @subpackage Structs
 */
class ArtikelMenge extends AbstractStructBase
{
    /**
     * The Pzn
     * Meta informations extracted from the WSDL
     * - documentation: PZN oder auch EAN TODO: Restrictions einbauen.
     * @var int
     */
    public $Pzn;
    /**
     * The Menge
     * Meta informations extracted from the WSDL
     * - maxInclusive: 99999
     * - minInclusive: 1
     * @var int
     */
    public $Menge;
    /**
     * Constructor method for ArtikelMenge
     * @uses ArtikelMenge::setPzn()
     * @uses ArtikelMenge::setMenge()
     * @param int $pzn
     * @param int $menge
     */
    public function __construct($pzn = null, $menge = null)
    {
        $this
            ->setPzn($pzn)
            ->setMenge($menge);
    }
    /**
     * Get Pzn value
     * @return int|null
     */
    public function getPzn()
    {
        return $this->Pzn;
    }
    /**
     * Set Pzn value
     * @param int $pzn
     * @return \StructType\ArtikelMenge
     */
    public function setPzn($pzn = null)
    {
        $this->Pzn = $pzn;
        return $this;
    }
    /**
     * Get Menge value
     * @return int|null
     */
    public function getMenge()
    {
        return $this->Menge;
    }
    /**
     * Set Menge value
     * @param int $menge
     * @return \StructType\ArtikelMenge
     */
    public function setMenge($menge = null)
    {
        $this->Menge = $menge;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ArtikelMenge
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
